﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Statki.Model;

namespace Statki.Tests
{
    [TestClass]
    public class AddRandomShipTests
    {
        [TestMethod]
        public void ShouldReturnCorrectCoordinatesTwo()
        {
            int shipLength = 3;
            var testData = Fixtures.GenerateFieldMatrix(6);
            Ship ship = new Ship(new System.Collections.Generic.List<Field>() { testData[1, 1], testData[2, 1], testData[3, 1] });
            List<Field> potentialCoordinates = new List<Field>()
            {
                testData[0,3], testData[1,3], testData[2,3], testData[3,3], testData[4,3],testData[5,3],
                testData[0,4], testData[1,4], testData[2,4], testData[3,4], testData[4,4],testData[5,4],
                testData[0,5], testData[1,5], testData[2,5], testData[3,5], testData[4,5],testData[5,5],
                testData[5,0], testData[5,1], testData[5,2], testData[5,3], testData[5,4],testData[5,5]


            };

            var result = new AddRandomShip(testData).RandCoordinates(shipLength);

            Assert.IsTrue(result.All(c => potentialCoordinates.Any(b => b.Coordinate.X == c.Coordinate.X && b.Coordinate.Y == c.Coordinate.Y)));
        }
    }
}
