﻿using System;
using System.Collections.Generic;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Statki.Model;

namespace Statki.Tests
{
    [TestClass]
    public class BoardUnitTests
    {
        [TestMethod]
        public void AddCurrentShip_Added()
        {
            Gameplay gameplay = new Gameplay();
            FieldClickCheckerPlanning fieldClickCheckerPlanning = new FieldClickCheckerPlanning(gameplay);

            for (int i = 0; i < 4; i++)
                fieldClickCheckerPlanning.AddFieldToList(new Field(new Coordinate(1, i)));

            fieldClickCheckerPlanning.AddCurrentShip();
            Assert.AreEqual(gameplay.ShipCollectionPlayer1.Count, 1);
        }

        [TestMethod]
        public void CheckIf_FieldClickCheckerPlanning_MethodCheckFieldIfIsClickedOrContainShip_false1()
        {
            FieldClickCheckerPlanning fieldClickCheckerPlanning = new FieldClickCheckerPlanning(null);
            Assert.AreEqual(fieldClickCheckerPlanning.CheckIfFieldContainShip(null), false);
        }

        [TestMethod]
        public void CheckIf_FieldClickCheckerPlanning_MethodCheckFieldIfIsClickedOrContainShip_true()
        {
            Field field = new Field(new Coordinate(1, 2));
            FieldClickCheckerPlanning fieldClickCheckerPlanning = new FieldClickCheckerPlanning(null);
            fieldClickCheckerPlanning.AddFieldToList(field);
            Assert.AreEqual(fieldClickCheckerPlanning.CheckIfFieldContainShip(field), true);
        }

        [TestMethod]
        public void CheckIf_FieldClickCheckerPlanning_MethodCheckFieldIfIsClickedOrContainShip_false2()
        {
            Field field = new Field(new Coordinate(1, 2));
            List<Field> fields = new List<Field>
            {
                field
            };
            Ship ship = new Ship(fields);

            FieldClickCheckerPlanning fieldClickCheckerPlanning = new FieldClickCheckerPlanning(null);
            Assert.AreEqual(fieldClickCheckerPlanning.CheckIfFieldContainShip(field), false);
        }
    }
}
