﻿using Statki.Model;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Statki
{
    public partial class Form1 : Form
    {
        Gameplay gameplay;
        FieldClickCheckerPlanning fieldClickCheckerPlanning;
        BoardGUI board;

        public Form1()
        {
            InitializeComponent();
            addShipButton.Enabled = false;

            changePhaseButton.Enabled = false;

            gameplay = new Gameplay();
            fieldClickCheckerPlanning = new FieldClickCheckerPlanning(gameplay);

            board = new BoardGUI(Height, Width, gameplay, fieldClickCheckerPlanning);
            board.CreateMaps(panelPlanszy);
            board.OnBoardFieldClicked += Enable_Add_Ship_Button;
        }

        private void AddShipButton_Click(object sender, EventArgs e)
        {
            if(fieldClickCheckerPlanning.AddCurrentShip()){
                board.LockFields();
                addShipButton.Enabled = false;

                if (gameplay.AllShipsAreAdded)
                    changePhaseButton.Enabled = true;
            }
        }

        private void Enable_Add_Ship_Button(object sender, EventArgs e)
        {
            if(fieldClickCheckerPlanning.ClickedFields.Count > 0 && !gameplay.AllShipsAreAdded)
                addShipButton.Enabled = true;
            else addShipButton.Enabled = false;
        }

        private void ChangePhaseButton_Click(object sender, EventArgs e)
        {
            gameplay.LaunchAnotherPhase();
            board.StartGame();

            UpdateUI();
        }

        void UpdateUI()
        {
            switch (gameplay.GamePhase)
            {
                case GamePhase.PlanningPhase:
                    break;
                case GamePhase.ShootingPhase:
                    addShipButton.Enabled = false;
                    changePhaseButton.Enabled = false;
                    break;
                case GamePhase.ResumePhase:
                    break;
                default:
                    break;
            }
        }
    }
}
