﻿using Statki.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Statki
{
    public class FieldClickCheckerPlanning
    {
        public List<Field> ClickedFields { get; private set; }
        Gameplay Gameplay;

        public bool CheckIfFieldContainShip(Field field)
        {
            Field result = ClickedFields.Find(f => f.Equals(field));

            if(result != null)
            {
                return result.Ship == null ? true : false;
            }
            return false;
        }

        

        public void AddFieldToList(Field field)
        {
            ClickedFields.Add(field);
        }

        public void RemoveFieldToList(Field field)
        {
            ClickedFields.Remove(field);

        }

        public FieldClickCheckerPlanning(Gameplay gameplay)
        {
            ClickedFields = new List<Field>();
            Gameplay = gameplay;
        }

        //ToDo: Czy to konieczne pisać dwa razy to samo?
        /*private Direction CalculateDirection(IEnumerable<Field> fields)
        {
            return CalculateDirection(fields.Select(field => field.Coordinate));
        }

        private Direction CalculateDirection(IEnumerable<Coordinate> coordinates)
        {
            var x = coordinates.Select(c => c.X);
            return x.Max() == x.Min()? Direction.Vertical : Direction.Horizontal;
        }*/

        private bool checkShipIsProper()
        {
            Direction direction = AI.CalculateDirection(ClickedFields);
            int y = ClickedFields.Select(f => f.Coordinate.Y).Min();
            int x = ClickedFields.Select(f => f.Coordinate.X).Min();
            if (direction == Direction.Horizontal){
                if ((ClickedFields.Select(f => f.Coordinate.X).Max() - x + 1) == ClickedFields.Count){
                    return true;
                }
                
            }
            else
            {
                if ((ClickedFields.Select(f => f.Coordinate.Y).Max() - y + 1) == ClickedFields.Count){
                    return true;
                }
            }
            
            return false;
        }

        public bool AddCurrentShip(){
            if (ClickedFields.Count == Gameplay.ShipCurrentlyAdded){
                if (!ClickedFields.Any()) throw new ArgumentException("Próba dodania zero masztowca");
                if (checkShipIsProper()){
                    Ship ship = new Ship(ClickedFields);
                    Gameplay.AddShipToCollection(ship, PlayerEnum.PlayerOne);
                    Gameplay.NextShipToAdd();
                    return true;
                }
            }
            
            return false;
        }
    }
}