﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Statki.Model
{
    public class Ship
    {
        public int SizeOfShip => Fields.Count;
        public int CountOfHitFields => Fields.Count(field => field.FieldState == FieldState.Hit);
        public bool IsSunk => CountOfHitFields == SizeOfShip;
        public List<Field> Fields { get; private set; }

        public Ship(List<Field> fields)
        {
            // TODO: sprawdzenie czy lista nie jest pusta
            Fields = new List<Field>();
            foreach (Field pole in fields)
            {
                pole.AddShip(this);
                this.Fields.Add(pole);
            }
        }
        public bool Sunk()
        {
            return CountOfHitFields == SizeOfShip;
        }
        public List<Field> GetOccupietFields (Field[,] fields)
        {
            List<Field> listfields = new List<Field>();

            int lefttopX = Math.Max(Fields.Select(x => x.Coordinate.X).Min() - 1, 0);
            int lefttopY = Math.Max(Fields.Select(y => y.Coordinate.Y).Min() - 1, 0);

            int leftbottomX = Math.Max(Fields.Select(x => x.Coordinate.X).Min() - 1, 0);
            int leftbottomY = Math.Min(Fields.Select(y => y.Coordinate.Y).Max() + 1, fields.GetLength(1) -1);

            int rightbottomX = Math.Min(Fields.Select(x => x.Coordinate.X).Max() + 1, fields.GetLength(0) -1);
            int rightbottomY = Math.Min(Fields.Select(y => y.Coordinate.Y).Max() + 1, fields.GetLength(1) -1);

            int righttopX = Math.Min(Fields.Select(x => x.Coordinate.X).Max() + 1, fields.GetLength(0) -1);
            int righttopY = Math.Max(Fields.Select(y => y.Coordinate.Y).Min() - 1, 0);

            for (int i = lefttopX; i <= righttopX; i++)
            {
                for (int j= righttopY; j<= rightbottomY; j++)
                {
                    listfields.Add(fields[i, j]);
                }
            }

            return listfields;
        }
    }
}
